
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>spring boot中注册拦截器 / 憋错料</title>

    <meta name="description" content="spring boot中注册拦截器 拦截器是动态拦截Action调用的对象.它提供了一种机制可以使开发者可以定义在一个action执行的前后执行的代码,也可以在一个action执行前阻止其执行,同时也提供了一种可以提取action中可重用部分的方式.在AOP(Aspect-Oriented Programming)中拦截器用于在某个方法或字段被访问之前,进行拦截然后在之前或之后加入某些操作. 如何在spring boot中添加拦截器? 1.首先自己实现一个拦截器 import org.springframework.web.ser">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">spring boot中注册拦截器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　拦截器是动态拦截Action调用的对象。它提供了一种机制可以使开发者可以定义在一个action执行的前后执行的代码，也可以在一个action执行前阻止其执行，同时也提供了一种可以提取action中可重用部分的方式。在AOP（Aspect-Oriented Programming）中拦截器用于在某个方法或字段被访问之前，进行拦截然后在之前或之后加入某些操作。</p>
<p>　　如何在spring boot中添加拦截器？</p>
<p>　　1.首先自己实现一个拦截器</p>
<pre>import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class MyInterceptor implements HandlerInterceptor{
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        System.out.println("preHandler");
        return true;//这里一定要返回true要不然后面的不会执行
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {
        System.out.println("postHandler");
    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
        System.out.println("afterHandler");
    }
}</pre>
<p>　　2.实现WebMvcConfigurer接口并重写addInterceptors方法</p>
<pre>@Configuration
public class WebMvcConfig implements WebMvcConfigurer {

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(myInterceptor()).addPathPatterns("/**");//将自己的拦截器注册到spring中并添加拦截的路径
    }
    @Bean
    MyInterceptor myInterceptor(){
        return new MyInterceptor();//提供自己的拦截器的bean
    }
}</pre>
<p>　　3.创建controller进行测试</p>
<pre>@RestControllerpublic class HelloController {    @GetMapping("gethello")    public String getHello(){        System.out.println("get hello");        return "get hello";    }}</pre>
<p>　　4.测试结果</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxOTEwLzIwMTkxMDI2MDEzMjU1MzAxMTUyLnBuZw==.jpg" /></p>

<p>原文地址：https://www.cnblogs.com/hopeofthevillage/p/11741422.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-09 07:37:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/add/" title="add">add</a>, <a href="https://www.biecuoliao.com/tag/min/" title="min">min</a>, <a href="https://www.biecuoliao.com/tag/img/" title="img">img</a>, <a href="https://www.biecuoliao.com/tag/exce/" title="exce">exce</a>, <a href="https://www.biecuoliao.com/tag/%e9%87%8d%e7%94%a8/" title="重用">重用</a>, <a href="https://www.biecuoliao.com/tag/gis/" title="gis">gis</a>, <a href="https://www.biecuoliao.com/tag/ddp/" title="ddp">ddp</a>, <a href="https://www.biecuoliao.com/tag/mvcc/" title="mvcc">mvcc</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>spring boot中注册拦截器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j7kLe3.html" rel="bookmark">spring mvc中的拦截器小结 &period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在spring mvc中,拦截器其实比较简单了,下面简单小结并demo下. preHandle:预处理回调方法,实现处理器的预处理(如登录检查),第三个参数为响应的处理器(如我们上一章的Controller实现):      返回值:true表示继续流程(如调用下一个拦截器或处理器):              false表示流程中断(如登录检查失败),不会继续调用其他的拦截器或处理器,此时我们需要通过response来产生响应: postHandle:后处理回调方法,实现处理器的后处理(但在渲			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49QRNJ4.html" rel="bookmark">Spring MVC中的拦截器&sol;过滤器HandlerInterceptorAdapter的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般情况下,对来自浏览器的请求的拦截,是利用Filter实现的 而在Spring中,基于Filter这种方式可以实现Bean预处理.后处理. 比如注入FilterRegistrationBean,然后在这个Bean上传递自己继承Filter实现的自定义Filter进入即可. 而Spring MVC也有拦截器,不仅可实现Filter的所有功能,还可以更精确的控制拦截精度. Spring MVC提供的org.springframework.web.servlet.handler.HandlerInt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV9gRd4.html" rel="bookmark">Spring MVC中的拦截器Interceptor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				谈谈spring中的拦截器 在web开发中,拦截器是经常用到的功能.它可以帮我们验证是否登陆.预先设置数据以及统计方法的执行效率等等.今天就来详细的谈一下spring中的拦截器.spring中拦截器主要分两种,一个是HandlerInterceptor,一个是MethodInterceptor. 一,HandlerInterceptor拦截器 HandlerInterceptor是springMVC项目中的拦截器,它拦截的目标是请求的地址,比MethodInterceptor先执行.实现一个Ha			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVnNRzM.html" rel="bookmark">【Spring Boot】Spring Boot之自定义拦截器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.拦截器的作用 将通用的代码抽取出来,达到复用的效果.比如可以用来做日志记录.登录判断.权限校验等等 二.如何实现自定义拦截器 1)创建自定义拦截器类并实现HandlerInterceptor类 /** * @author zhangboqing * @date 2019-07-28 */ public class MyInterceptor implements HandlerInterceptor { /** * 执行Controller方法之前,调用 */ @Override publi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MD7Exw4.html" rel="bookmark">Spring mvc中自定义拦截器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.要实现的一个功能: 1.打开特定的一些页面时必需强制用户进行登录. 2.登录后再返回到之前的页面. 二.先写一个service,实现从cookie中判断用户是否登录. 1.TT_TOKEN为登录成功时,响应给浏览器的Cookie的键. @Service public class UserServiceImpl implements UserService{ @Value(&quot;${SSO_BASE_URL}&quot;) private String SSO_BASE_URL; @Value(&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rg7Oq4.html" rel="bookmark">spring aop中引介拦截器的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public class Other implements IntroductionInterceptor,IOther{ public void doOther(){ System.out.println(&quot;Other对象的功能&quot;); } public Object invoke(MethodInvocation methodInvocation) throws Throwable { if(implementsInterface(methodInvocation.getMethod			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDBY9o3.html" rel="bookmark">spring boot中常用的配置文件的重写</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				@Configuration public class viewConfigSolver extends WebMvcConfigurerAdapter { /* spring boot 已经自动配置好了springmvc 配置好了viewResolver * 视图解析器(根据方法的返回值得到视图对象,视图对象决定如何渲染(转发或者重定向)) * 我们可以自己给容器中添加一个视图解析器 * ContentNegotiatingViewResolver就会将其组合进来*/ @Override pu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Ondag0.html" rel="bookmark">Spring AOP原理及拦截器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原理 AOP(Aspect Oriented Programming),也就是面向方面编程的技术.AOP基于IoC基础,是对OOP的有益补充. AOP将应用系统分为两部分,核心业务逻辑(Core business concerns)及横向的通用逻辑,也就是所谓的方面Crosscutting enterprise concerns,例如,所有大中型应用都要涉及到的持久化管理(Persistent).事务管理(Transaction Management).安全管理(Security).日志管理(L			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/g41GEJ0.html" rel="bookmark">spring mvc 方法注解拦截器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				应用场景,在方法级别对本次调用进行鉴权,如api接口中有个用户唯一标示accessToken,对于有accessToken的每次请求可以在方法加一个拦截器,获得本次请求的用户,存放到request或者session域. python中,之前在python flask中可以使用装饰器来对方法进行预处理,进行权限处理 先看一个实例,使用@access_required拦截: @api.route('/post_apply') @access_required def apply():     &quot;&q			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/E3wvqb0.html" rel="bookmark" class="title">java杂记-static</a>
					<div>
						首先是static的概念 借鉴 http://lavasoft.blog.51cto.com/62575/18771/  (好吧,都是复制这个的.写的很好,所以我就复制了) static表示&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQXeL3.html" rel="bookmark" class="title">Xamarin&period;Form 下拉刷新动画</a>
					<div>
						好像园子里对 Xamarin 感兴趣的人很少啊... 来, 先给各位爷们逗个笑, 本山大爷本色出演: 照例, 上源码: https://github.com/gruan01/ListViewExten ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knPkbM.html" rel="bookmark" class="title">MessageFormat类&colon;快速格式化字符串</a>
					<div>
						MessageFormat 获取一组对象,格式化这些对象,然后将格式化后的字符串插入到模式中的适当位置. 第一个例子使用静态的方法 MessageFormat.format,它在内部创建一个只使用一次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYBjG0.html" rel="bookmark" class="title">Ueditor的使用</a>
					<div>
						最近在做一个网站,之前使用的是KindEditor.然后负责人说要求换一个新的文本编辑器,于是就选择了百度的Ueditor.初次使用花了很大的力气才搞懂.不过确实挺好用的.下面就将使用方法与大家分享. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5qx24.html" rel="bookmark" class="title">寒假week1---二分查找（二分枚举）</a>
					<div>
						寒假week1---二分查找(二分枚举)1.适用条件:要查找(枚举)的集合有序 &amp;&amp; 查找(枚举)的&quot;条件&quot;具有单调性2.什么是&quot;条件&quot;:exa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvvKG4.html" rel="bookmark" class="title">Spring学习笔记--代理</a>
					<div>
						静态代理 1.静态代理的角色分析(UML画图推荐使用StarUML软件) 抽象角色---一般使用接口或者抽象类来实现. 真是角色---被代理的角色. 代理角色---代理真实角色-代理真是角色后一般会做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV88Aw3.html" rel="bookmark" class="title">oracle &amp;nbsp&semi; SQL执行过程</a>
					<div>
						1.sql执行过程 1&gt;解析(判断对象是否存在,是否有权限查询,语义解析,检查缓存中是否有相同的SQL等等) 2&gt;优化(CBO确定优化模式,确定访问路径,联接顺序,过程中通过很多综合因素估 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41z2ZqM.html" rel="bookmark" class="title">ArcGisJS的layers-add-result事件总结</a>
					<div>
						map.on(&quot;layers-add-result&quot;, initEditing);当地图控件中的所有图层加载完毕之后触发. 注意图层加载完成后返回的的结果:event. funct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDZpwM.html" rel="bookmark" class="title">BZOJ 2346 Lamp</a>
					<div>
						不建边表是一定比建边表要快的. 对角线跑最短路. #include&lt;iostream&gt; #include&lt;cstdio&gt; #include&lt;cstring&gt; #in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGRqVa4.html" rel="bookmark" class="title">android gradle</a>
					<div>
						Gradle编译时报错:gradle:peer not authenticated处理方法:Change your repository syntax to one of the following  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWwy13.html" rel="bookmark" class="title">用java实现sql server中的datediff函数</a>
					<div>
						1 /** 2 * 计算两个时间的相差值, 可以计算相差的天数, 年数, 月份数, 分钟数, 秒数 3 * 4 * @param dateType 要得到的两个时间之间差值的类型, 例如要得到两个时间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k986b4.html" rel="bookmark" class="title">SUSE配置网关</a>
					<div>
						配置SUSE Linux Enterprise Server 11 (x86_64)的网关 vim /etc/sysconfig/network/routes default 192.168.1.1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgRDzB4.html" rel="bookmark" class="title">CKEditor上传图片&mdash;配置CKFinder</a>
					<div>
						在网站开发中,如果有发布类似新闻的图文混排需求时,CKEditor不失为一个很好的选择,下载地址如下: http://ckeditor.com/download 它的前身是FCKEditor,随着它的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBGXj4.html" rel="bookmark" class="title">CSS3 2D 转换</a>
					<div>
						2D 转换 在本章中,您将学到如下 2D 转换方法: translate() rotate() scale() skew() matrix() 您将在下一章学习 3D 转换. 实例 div { tra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y1deO0.html" rel="bookmark" class="title">图解说明&mdash;&mdash;究竟什么是Windows句柄</a>
					<div>
						图解说明——究竟什么是Windows句柄 参考资料:http://blog.csdn.net/newjerryj/article/details/4383701 http://www.cnblogs. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v1WWg0.html" rel="bookmark" class="title">hashMap解读</a>
					<div>
						当初来公司时候,被问了一个问题,叫重写一个hashMap怎么写.数据结构捉鸡...所以,现在决定补上这东西. 好啦,首先,先写点东西. HashMap 和 HashSet 是 Java Collect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Opj6g4.html" rel="bookmark" class="title">Chapter3 中断、时钟和低功耗</a>
					<div>
						1.中断 ①轮询方式和中断方式 轮询(Polling)方式:CPU主动对外设进行查询,外设处于被动地位,执行效率低下,等待时间长. 中断(Interrupt)方式:CPU通过响应中断请求为外设提供服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lDO1N0.html" rel="bookmark" class="title">模式匹配KMP</a>
					<div>
						字符串朴素模式匹配算法的2种实现: //1.朴素的模式匹配算法,用while实现 int StrStr_While(const char* pStr, const char* pSub, int* p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDWbGM.html" rel="bookmark" class="title">C&num;调用WCF问题汇总</a>
					<div>
						1.添加服务后无法引用,添加服务时打开高级,将下面的选项去掉就可以引用了. 2.在程序中引用后,运行时报&quot;找不到引用协定''的默认终结点元素&quot;错误,这是由于在工程的App.conf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWDKy4.html" rel="bookmark" class="title">pipework安装 及分配容器固定IP</a>
					<div>
						OS:centos7.0 第一步: [email protected] ~]# yum -y install git 第二步: [[email protected] ~]# git clone htt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
